import { EventEmitter, SimpleChanges, OnChanges } from '@angular/core';
import { TreeviewI18n } from './treeview-i18n';
import { TreeviewItem } from './treeview-item';
import { TreeviewConfig } from './treeview-config';
import { TreeviewEventParser } from './treeview-event-parser';
export declare class TreeviewComponent implements OnChanges {
    i18n: TreeviewI18n;
    private defaultConfig;
    private eventParser;
    items: TreeviewItem[];
    config: TreeviewConfig;
    selectedChange: EventEmitter<any[]>;
    allItem: TreeviewItem;
    filterText: string;
    filterItems: TreeviewItem[];
    checkedItems: TreeviewItem[];
    constructor(i18n: TreeviewI18n, defaultConfig: TreeviewConfig, eventParser: TreeviewEventParser);
    readonly hasItems: boolean;
    readonly hasFilterItems: boolean;
    readonly maxHeight: string;
    ngOnChanges(changes: SimpleChanges): void;
    toggleCollapseExpand(): void;
    onFilterTextChange(): void;
    onAllCheckedChange(checked: boolean): void;
    onItemCheckedChange(item: TreeviewItem, checked: boolean): void;
    private getCheckedItems();
    private onAfterSelectedChange();
    private updateFilterItems();
    private filterItem(item, filterText);
    private updateCheckedAll();
    private updateCollapsedAll();
}
